/*
	File:		PartUtils.h

	Contains:	Part utility functions & classes

	Owned by:	Reggie Adkins

	Change History (most recent first):

	<5>	4/14/95	JS		Updated for Developer Release 2
	<2>	3/8/95	JS		Updated to b1c13/c14
	<1>	2/2/95	RA		first checked in
	<0>	PartMaker source by E, Soldan, T. elik, J. Alfke, R. Adkins, J. Schalk
*/


#ifndef _PARTUTILS_
#define _PARTUTILS_

#ifndef __EVENTS__
#include <Events.h>
#endif

#ifndef __DIALOGS__
#include <Dialogs.h>
#endif

//----------------------------------------------------------------------------------------

class ODSession;
class ODWindow;
struct ODPoint;

extern ODSession* gSession;

#define TopLeft(aRect)	(* (Point *) &(aRect).top)
#define BotRight(aRect)	(* (Point *) &(aRect).bottom)

#define Width(aRect)	((aRect).right-(aRect).left)
#define Height(aRect)	((aRect).bottom-(aRect).top)

//----------------------------------------------------------------------------------------

#ifdef __cplusplus
extern "C" {
#endif

extern pascal Boolean MyDialogFilter(DialogPtr dialog, EventRecord* event, short* itemHit);

extern void GetWindowPoint(ODWindow *w, Environment *ev,
							Point globalPoint,
							ODPoint *localPoint);

#ifdef __cplusplus
}
#endif

#endif

